<template>
  <rui-empty v-if="activities.length === 0" :content="$t('js.app.garden.page.activities.no_activities')" />

  <section v-for="(data, day) in activitiesByDay" :key="day" class="gpa-activities__day">
    <h2>{{ day }}</h2>
    <gpa-activity v-for="activity in data.activities" :key="activity.id" :activity="activity" />
  </section>
</template>

<script>
import RuiEmpty from '@experiments-labs/rise_ui/src/components/DataDisplay/Empty/Empty.vue'

import GpaActivity from './_Activity.vue'

/**
 * Displays a list of activities, day by day
 */
export default {
  name: 'GpaActivities',
  components: { RuiEmpty, GpaActivity },
  props: {
    /** List of Activities to display */
    activities: { required: true, type: Array },
  },
  computed: {
    activitiesByDay () {
      return this.activities
        .slice()
        .reverse()
        // Group by day
        .reduce((result, activity) => {
          const date = this.$d(activity.happenedAt, 'date')
          if (!result[date]) result[date] = { date: activity.happenedAt, activities: [] }
          result[date].activities.push(activity)
          return result
        }, {})
    },
  },
}
</script>
